"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tailwindConfig_1 = require("./tailwindConfig");
const transformUtils_1 = require("./transformUtils");
const MODULES = ["xwind", "xwind/macro"];
function babel(babel, config, workingPath) {
    const { types: t } = babel;
    const twConfigPath = tailwindConfig_1.getTwConfigPath(config.config);
    return {
        name: "xwind",
        visitor: {
            ImportDefaultSpecifier(path, state) {
                //get referencePaths for default import from "xwind" or "xwind/macro"
                if (!path.parentPath.isImportDeclaration())
                    return;
                if (path.parent.type !== "ImportDeclaration")
                    return;
                if (!MODULES.includes(path.parent.source.value))
                    return;
                const referencePaths = path.scope.bindings[path.node.local.name].referencePaths;
                //remove default import and remove import if no other specifiers exist
                path.remove();
                if (path.parent.specifiers.length === 0) {
                    path.parentPath.remove();
                }
                if (!referencePaths.length)
                    return;
                const transformer = transformUtils_1.getCachedTransformer(twConfigPath);
                transformer(referencePaths, state, t);
            },
        },
    };
}
exports.default = babel;
//# sourceMappingURL=babel.js.map