"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const babel_plugin_macros_1 = require("babel-plugin-macros");
const tailwindConfig_1 = require("./tailwindConfig");
const transformUtils_1 = require("./transformUtils");
function xwindMacro({ references: { default: paths }, state, babel: { types: t }, config, }) {
    try {
        const twConfigPath = tailwindConfig_1.getTwConfigPath(config === null || config === void 0 ? void 0 : config.config);
        const transformer = transformUtils_1.getCachedTransformer(twConfigPath);
        transformer(paths, state, t);
    }
    catch (err) {
        err.message = `xwind/macro - ${err.message}`;
        throw new babel_plugin_macros_1.MacroError(err);
    }
}
exports.default = babel_plugin_macros_1.createMacro(xwindMacro, {
    configName: "xwind",
});
//# sourceMappingURL=macro.js.map